#!/usr/bin/perl
# extraction de rsultats dans les fichiers produits par transport.pl et tunnel.pl
sub analyse {

    my $num = -1;                    # N du test
    my $transp = 'unk';              # udp ou tcp
    my $size_sock_send = -1;         # taille socket emission
    my $size_sock_recv = -1;         # taille socket rception
    my $size_msg = -1;               # taille des messages
    my $sens = 'unk';                # half ou full duplex
    my $protoconf = 'unk';           # esp ou none
    my $protoauth = 'unk';           # ah, esp ou none
    my $algoconf = 'unk';
    my $algoauth = 'unk';
    my $tailleclefauth = 'unk';
    my $tailleclefconf = 'unk';
    my $debit_netperf_emet = -1;
    my $debit_netperf_recv = -1;
    my $debit_ttcp_emet = -1;
    my $debit_ttcp_recv = -1;
    
    my $line = <FILE>;
    if (!$line) {
	return;
    }
    while ($line !~ /Test N/) {
	$line = <FILE>; 
    }
    
  TESTHEADER: {
      $auth = 0;
      $conf = 0;
      if ($line =~ /Test N/) {
	  $line =~ s/Test N// ;
	  $line =~ s/\ +tmoin/:/;
	  if ($line =~ / Protocole de confidentialit: /) {
	      $line =~ s/ Protocole de confidentialit: /:/;
	      $conf = 1;
	  } elsif($line =~ / Protocole d\'authentification: /) {
	      $line =~ s/ Protocole d\'authentification: /:/;
	      $auth = 1;
	      }
	      $line =~ s/; Algorithme: /:/;
	      $line =~ s/;* Clef: \"/:/;
	      $line =~ s/\"//;
	      $line =~ s/\ *\n//;
	      if ($auth == 1) {
		  ($num, $protoauth, $algoauth, $clefauth) = split(/:+/, $line);
	      } elsif ($conf == 1) {
		  ($num, $protoconf, $algoconf, $clefconf) = split(/:+/, $line);
	      }

	  }
      }
      

	$line = <FILE> ;
	if ($line =~ /Test N/) {
	    goto TESTHEADER;
	}

	if ($protoconf eq 'unk') {
	    $protoconf = 'none';
	    $algoconf = 'none';
	    $tailleclefconf = 'none' ;
	} else {
	    $tailleclefconf = $clefconf ? 8 * length $clefconf : -1;
	}

	if ($protoauth eq 'unk') {
	    $protoauth = 'none';
	    $algoauth = 'none';
	    $tailleclefauth = 'none' ;
	} else {
	    $tailleclefauth = $clefauth ? 8 * length $clefauth : -1;
	}

#analysons maintenant les donnes que nous incluons
      SOCKPARAMS: {
	  if ($line =~ /recv_socket_size: /) {
	      $line =~ s/recv_socket_size: //;
	      $line =~ s/ ; send_socket_size: /:/;
	      $line =~ s/ ; send_msg_size: /:/;
	      $line =~ s/ ; tcp: /:/;
	      $line =~ s/; sens: /:/;
	      $line =~ s/\n/:/;
	      ($size_sock_recv, $size_sock_send, $size_msg, $tmptcp, $sens) = split(/:+/, $line);
	      if ($tmptcp eq '1') {
		  $transp = 'tcp';
	      } else {
		  $transp = 'udp';
	      }
	  }
      }

#analysons les donnes de ttcp
      TTCP: {
	  while ($line !~ /ttcp6-t: buflen=/) {
		  $line = <FILE>;
		  if (!$line) {
		      return ;
		  }
	  }
	  $line = <FILE>;
	  if ($line =~ /sockbufsize=/) {
	      $line = <FILE>;
	  } else {
	      die "erreur dans le traitement des donnes ttcp\n" ;
	  }
	  if ($line =~ /\# tcp sender -> /) {
	      $line = <FILE>;
	  } else {
	      die "erreur dans le traitement des donnes ttcp\n" ;
	  }
	  $line =~ s/ttcp6-t: //;
	  $line =~ s/ bytes in /:/;
	  $line =~ s/ real seconds = /:/;
	  $line =~ s/ Mbit\/sec \+\+\+\n// ;
	  ( $foo, $bar, $debit_ttcp_emet ) = split(/:+/, $line);
	  $line = <FILE> ;
	  

      }

#analysons les donnes de netperf
      NETPERF: {
	  while (($line !~ /TCPIPV6 STREAM TEST to /) && ($line !~ /UDPIPV6 STREAM TEST to /)) {
	      $line = <FILE> ;
	      if (!$line) {
		  return ;
	      }
	  }
	  $line = <FILE> ;
	  $line = <FILE> ;
	  $line = <FILE> ;
	  $line = <FILE> ;
	  $line = <FILE> ;
	  $line = <FILE> ;
	  ( $foobar, $foo, $bar, $foo, $bar, $debit_netperf_emet) = split(/\ +/, $line);
      }
    return ($num, $transp, $size_sock_send, $size_sock_recv, $size_msg, $sens, $protoconf, $protoauth, $algoconf, $algoauth, $tailleclefauth, $tailleclefconf, $debit_netperf_emet, $debit_netperf_recv, $debit_ttcp_emet, $debit_ttcp_recv);
	
}

####################################################

open FILE, $ARGV[0];

$taille_sock_em = 65536;
$taille_sock_re = 65536;
$taille_msg_em = 32768;

$alg_conf = 'none';
$alg_auth = 'none';
$proto_auth = 'ah';
$sen = 'half';

$x = 0;
while (1) {
    ($num, $transp, $size_sock_send, $size_sock_recv, $size_msg, $sens, $protoconf, $protoauth, $algoconf, $algoauth, $tailleclefauth, $tailleclefconf, $debit_netperf_emet, $debit_netperf_recv, $debit_ttcp_emet, $debit_ttcp_recv) = analyse;
    if (!$num) {
	last;
    }

    $y = !($x % 2) ? -5 : -12;
    if ($taille_sock_em == $size_sock_send) { # changer les conditions selon ce que vous voulez rcuprer
	if ($taille_sock_re == $size_sock_recv) {
	    if ($taille_msg_em == $size_msg) {
		if ($alg_conf eq $algoconf) {
		    if ($proto_auth eq $protoauth) {
			if ($sen eq $sens) {
			    $varimp = $algoauth;
    			    # mettre ici ce que vous voulez faire
			    $x++;
			}
		    }
		}
	    }
	}
    }

}

close FILE;
