#!/usr/bin/perl -P
# tests IPsec/IPv6 en mode transport avec FreeBSD

use POSIX "sys_wait_h";
use Socket;

$SETKEY='/usr/sbin/setkey' ;
$TTCP='/opt/ttcp6';
$NETPERF='/opt/netperf/netperf'; 
$NETSERVER='/opt/netperf/netserver'; 

$testnum = 0;

$typetest = 0;

# Fonction pour rinitialiser la SAD et la SPD
sub reinit_tabs {
    system $SETKEY , "-F";
    system $SETKEY , "-FP";
}

sub usage {
    die "Usage: \n \t transport -t|-u addr_src_ipv6 addr_src_ipv4 hostname_src addr_dst_ipv6 addr_dst_ipv4 hostname_dst\n";
}

# Une petite macro pour ne pas recopier toujours la mme chose...
# !!! ATTENTION !!! On ne dtecte peut-tre pas toutes les erreurs! En cas d'erreur grave, il faut faire attention avec les rsultats, l'erreur peut s'tre produite 
# plus tt mais tre passe inaperue...
#Pour tre propre, il faudrait vrifier le numro du test
#define DOTEST  $recu = ' '; \
                if ($typetest == 2) { \
			$nberr = 0; \
			while ($recu ne "OK\n") { \
			    recv(CONTROLE, $recu, 3, 0); \
			}  \
                        print "\nTest ttcp6\n"; \
			if ($tcp) { \
			    print "$TTCP -f m -t $addr_dst_ipv6" ; \
			    while(system("$TTCP -b $send_socket_size -l $send_msg_size -f m -t $addr_dst_ipv6 >> /tmp/tests_ipv6_results.txt")) { \
				print "\n\n**** Une erreur s'est produite ****\n\n"; \
				if ($nberr++ >= 5) { \
				    die "\nErreur grave\n" \
				    } \
			    } \
			    print "\nTest NetPerf \n"; \
			    system("$NETPERF -t TCPIPV6_STREAM -H $hostname_dst -- -S $recv_socket_size -s $send_socket_size -m $send_msg_size >> /tmp/tests_ipv6_results.txt"); \
			    send(CONTROLE, "OK\n", 0); \
			} else { \
			    while(system("$TTCP -b $send_socket_size -l $send_msg_size -u -f m -t $addr_dst_ipv6")) { \
				print "\n\n**** Une erreur s'est produite ****\n\n"; \
				if ($nberr++ >= 5) { \
				    die "\nErreur grave\n" \
				    } \
			    } \
			    print "\nTest NetPerf \n"; \
			    system("$NETPERF -t UDPIPV6_STREAM -H $hostname_dst -- -S $recv_socket_size -s $send_socket_size -m $send_msg_size >> /tmp/tests_ipv6_results.txt"); \
			    send(CONTROLE, "OK\n", 0); \
			} \
		    } elsif ($typetest == 1) { \
			if ($tcp) { \
			    print $TTCP, " -f m -r "; \
			    if (($pid = fork)) { \
				send(CONTROLE, "OK\n", 0); \
				waitpid($pid, 0); \
			    } else { \
				exec "$TTCP -b $recv_socket_size -l $send_msg_size -f m -r >> /tmp/tests_ipv6_results.txt"; \
			    } \
			} else { \
			    print $TTCP, " -u -f m -r "; \
			    if (fork) { \
				send(CONTROLE, "OK\n", 0); \
				waitpid($pid, 0); \
			    } else { \
				exec "$TTCP -b $recv_socket_size -l $send_msg_size -u -f m -r >> /tmp/tests_ipv6_results.txt"; \
			    } \
			} \
			while ($recu ne "OK\n") { \
			    recv(CONTROLE, $recu, 3, 0); \
			} \
		    } 

@CLEF_AUTH = ('"TESTtestTESTtest"', '"TESTtestTESTtestTEST"', '"TESTtestTESTtest"', '"TESTtestTESTtestTEST"',
	      '"TESTtestTESTtestTESTtestTESTtest"', '"TESTtestTESTtestTESTtestTESTtestTESTtestTESTtest"',
	      '"TESTtestTESTtestTESTtestTESTtestTESTtestTESTtestTESTtestTESTtest"');
@CLEF_CONF = ('"TESTtest"', '"TESTtestTESTtestTESTtest"', '""', '"TESTtestTESTtestTESTtestTESTtestTESTtestTESTtestTESTtestTESTtestTESTtest"',
	      '"TESTtestTESTtest"', '"TESTtestTESTtestTESTtestTESTtest"', '"TESTtestTESTtestTESTtestTESTtestTESTtestTESTtestTESTtest"',
	      '"TESTtestTESTtest"', '"TESTtest"', '"TESTtestTESTtest"', '"TESTtestTESTtestTESTtest"', '"TESTtestTESTtestTESTtestTESTtest"');

# On scanne les arguments
if (@ARGV != 7) {
    usage ;
}
if ($ARGV[0] eq "-r") {
    print "Mode recepteur\n";
    $typetest = 1;
    $out = 'in';
} elsif ($ARGV[0] eq "-t") {
    print "Mode emetteur\n"; 
    $typetest = 2;
    $out = 'out';
} else {
    usage;
}

$addr_src_ipv6 = $ARGV[1];
$addr_src_ipv4 = $ARGV[2];
$hostname_src = $ARGV[3];
$addr_dst_ipv6 = $ARGV[4];
$addr_dst_ipv4 = $ARGV[5];
$hostname_dst = $ARGV[6];

#socket de controle (pour la synchronisation)
# La socket de controle utilise IPv4, IPv6 n'tant pas encore support par Perl
if ($typetest == 1) {
    print "Etablissement de la socket de controle: en attente de connexion\n";
    socket(TEMP, AF_INET, SOCK_STREAM, 0) || die $! ;
    my $addr_local = sockaddr_in (12864, INADDR_ANY);
    bind (TEMP, $addr_local) || die $!;
    listen(TEMP, 1) ;
    accept(CONTROLE, TEMP,) || die $!;
    close(TEMP);
} else {
    print "Etablissement de la socket de controle: \n";
    socket(CONTROLE, AF_INET, SOCK_STREAM, 0) || die $! ;
    my $addr_local = sockaddr_in (0, INADDR_ANY);
    my $addr_dist = sockaddr_in (12864, inet_aton($addr_dst_ipv4));
    bind(CONTROLE, $addr_local)|| die $!;
    connect (CONTROLE, $addr_dist) || die $!;
}
print "Etablissement de la socket de controle: OK\n";

#******** tests **********************
open(RESULTS, ">/tmp/tests_ipv6_results.txt") or die "Could not open /tmp/tests_ipv6_results.txt\n";

if ($typetest == 1) {
# Lancement de netserver
    $pid=fork;
    if (!$pid) {
	exec "$NETSERVER -p 12865";
    }
}

for ($tcp = 1; $tcp >= 0; $tcp--) {
    foreach $recv_socket_size ('65536', '32768', '8192', '4096') { ##taille du buffer de la socket  la rception
	foreach $send_socket_size ('65536', '32768', '8192', '4096') {##taille du buffer de la socket  l mission
	   foreach $send_msg_size ('4096', '8192', '32768') { ##taille des messages envoys (pour netperf) / du buffer de message (ttcp)
		reinit_tabs;
		print "\nTest N$testnum: tmoin\n";
		print RESULTS "\nTest N$numtest: tmoin\n";
		print RESULTS "recv_socket_size: $recv_socket_size ; send_socket_size: $send_socket_size ; send_msg_size: $send_msg_size ; tcp: $tcp\n";
		close RESULTS;
		DOTEST ;
		$testnum++;
 
		foreach $what ('half', 'full') { ## avec full, on utilise IPsec dans les deux sens. avec half, uniquement de lmetteur vers le rcepteur
		    print "\nTests d'authentification\n";
		    foreach $PROTO ('ah') {
			$NUMCLEFAUTH = 0;
			foreach $ALGO ('hmac-md5', 'hmac-sha1', 'keyed-md5', 'keyed-sha1', 'hmac-sha2-256', 'hmac-sha2-384', 'hmac-sha2-512') {
			    open(RESULTS, ">>/tmp/tests_ipv6_results.txt") or die "Could not open /tmp/tests_ipv6_results.txt\n";
			    print "\n\nTest N", $testnum, ' Protocole d\'authentification: ', $PROTO, '; Algorithme: ', $ALGO, "\n";
			    print RESULTS "\n\nTest N", $testnum, ' Protocole d\'authentification: ', $PROTO, '; Algorithme: ', $ALGO, "\n";
			    print RESULTS "recv_socket_size: $recv_socket_size ; send_socket_size: $send_socket_size ; send_msg_size: $send_msg_size ; tcp: $tcp; sens: $what\n";
			    close RESULTS;
			    open ( TMP, ">/tmp/tests.tmp") or die "Could not open /tmp/tests.tmp\n";
			    $v = print TMP "add ", $addr_src_ipv6, ' ', $addr_dst_ipv6, ' ', $PROTO, " 1000 -A ", $ALGO, ' ', $CLEF_AUTH[$NUMCLEFAUTH],
			    '; spdadd ', $addr_src_ipv6, ' ', $addr_dst_ipv6, ' any -P ', "$out", ' ipsec ', $PROTO, "/transport/", $addr_src_ipv6,
			    "-", $addr_dst_ipv6, '/require ;' ;
#	    bbb if (!v) { die "Erreur d'ecriture dans un fichier"} 
			    if ($what eq 'full') {
				print TMP "add ", $addr_dst_ipv6, ' ', $addr_src_ipv6, ' ', $PROTO, " 1000 -A ", $ALGO, ' ', $CLEF_AUTH[$NUMCLEFAUTH],
				'; spdadd ', $addr_dst_ipv6, ' ', $addr_src_ipv6, ' any -P ', "$out", ' ipsec ', $PROTO, "/transport/", $addr_dst_ipv6,
				"-", $addr_src_ipv6, '/require ;' ;
			    }
			    close TMP ;
			    system ($SETKEY, '-f', '/tmp/tests.tmp') ;
			    
			    DOTEST ;
			    reinit_tabs ;
			    $testnum++;
			    $NUMCLEFAUTH++;
			}
		    }

		    print "\nTests de confidentialit\n";
		    foreach $PROTO ('esp') {
			$NUMCLEFCONF = 0;
			foreach $ALGO ('des-cbc', '3des-cbc', 'simple', 'simple', 'blowfish-cbc', 'blowfish-cbc', 'blowfish-cbc', 'cast128-cbc', 'des-deriv', 'rijndael-cbc', 'rijndael-cbc', 'rijndael-cbc') {
			    open(RESULTS, ">>/tmp/tests_ipv6_results.txt") or die "Could not open /tmp/tests_ipv6_results.txt\n";
			    print "\n\nTest N", $testnum, ' Protocole de confidentialit: ', $PROTO, '; Algorithme: ', $ALGO, ' Clef: ', $CLEF_CONF[$NUMCLEFCONF],"\n";
			    print RESULTS "\n\nTest N", $testnum, ' Protocole de confidentialit: ', $PROTO, '; Algorithme: ', $ALGO, ' Clef: ', $CLEF_CONF[$NUMCLEFCONF],"\n";
			    print RESULTS "recv_socket_size: $recv_socket_size ; send_socket_size: $send_socket_size ; send_msg_size: $send_msg_size ; tcp: $tcp; sens: $what\n";
			    close RESULTS;
			    open ( TMP, ">/tmp/tests.tmp") or die "Could not open /tmp/tests.tmp\n";
			    $v = print TMP "add ", $addr_src_ipv6, ' ', $addr_dst_ipv6, ' ', $PROTO, " 1000 -E ", $ALGO, ' ', $CLEF_CONF[$NUMCLEFCONF],
			    '; spdadd ', $addr_src_ipv6, ' ', $addr_dst_ipv6, ' any -P ', "$out", ' ipsec ', $PROTO, "/transport/", $addr_src_ipv6,
			    "-", $addr_dst_ipv6, '/require ;' ;
#	    bb if (!v) { die "Erreur d'ecriture dans un fichier"} 
			    if ($what eq 'full') {
				print TMP "add ", $addr_dst_ipv6, ' ', $addr_src_ipv6, ' ', $PROTO, " 1000 -E ", $ALGO, ' ', $CLEF_CONF[$NUMCLEFCONF],
				'; spdadd ', $addr_dst_ipv6, ' ', $addr_src_ipv6, ' any -P ', "$out", ' ipsec ', $PROTO, "/transport/", $addr_dst_ipv6,
				"-", $addr_src_ipv6, '/require ;' ;
			    }
			    close TMP ;
			    system ($SETKEY, '-f', '/tmp/tests.tmp') ;
			    
			    DOTEST ;
			    
			    reinit_tabs ;
			    $testnum++;
			    $NUMCLEFCONF++;
			}
		    }
		    
		    print "\nTests de confidentialit avec authentification\n";
		    foreach $PROTO_AUTH ('esp', 'ah') {
			$NUMCLEFAUTH = 0;
			foreach $ALGO_AUTH ('hmac-md5', 'hmac-sha1', 'keyed-md5', 'keyed-sha1', 'hmac-sha2-256', 'hmac-sha2-384', 'hmac-sha2-512') {
			    foreach $PROTO ('esp') {
				$NUMCLEFCONF = 0;
				foreach $ALGO ('des-cbc', '3des-cbc', 'simple', 'simple', 'blowfish-cbc', 'blowfish-cbc', 'blowfish-cbc', 'cast128-cbc', 'des-deriv', 'rijndael-cbc', 'rijndael-cbc', 'rijndael-cbc') {
				    print "\n\nTest N", $testnum, ' Protocole de confidentialit: ', $PROTO, '; Algorithme: ', $ALGO, ' Clef: ', $CLEF_CONF[$NUMCLEFCONF],"\n";
				    print "Test N", $testnum, ' Protocole d\'authentification: ', $PROTO_AUTH, '; Algorithme: ', $ALGO_AUTH, ' Clef: ', $CLEF_AUTH[$NUMCLEFAUTH],"\n";
				    open(RESULTS, ">>/tmp/tests_ipv6_results.txt") or die "Could not open /tmp/tests_ipv6_results.txt\n";
				    print RESULTS "\n\nTest N", $testnum, ' Protocole de confidentialit: ', $PROTO, '; Algorithme: ', $ALGO, ' Clef: ', $CLEF_CONF[$NUMCLEFCONF],"\n";
				    print RESULTS "Test N", $testnum, ' Protocole d\'authentification: ', $PROTO_AUTH, '; Algorithme: ', $ALGO_AUTH, ' Clef: ', $CLEF_AUTH[$NUMCLEFAUTH],"\n";
				    print RESULTS "recv_socket_size: $recv_socket_size ; send_socket_size: $send_socket_size ; send_msg_size: $send_msg_size ; tcp: $tcp; sens: $what\n";
				    close RESULTS;
				    open ( TMP, ">/tmp/tests.tmp") or die "Could not open /tmp/tests.tmp\n";
				    if ($PROTO_AUTH eq "ah") { #AH
					print TMP "add ", $addr_src_ipv6, ' ', $addr_dst_ipv6, ' ', $PROTO, " 1000 -E ", $ALGO, ' ', $CLEF_CONF[$NUMCLEFCONF],
					";\n  add ", $addr_src_ipv6, ' ', $addr_dst_ipv6, ' ', $PROTO_AUTH, " 2000 -A ", $ALGO_AUTH, ' ', $CLEF_AUTH[$NUMCLEFAUTH], " ;\n spdadd ",
					$addr_src_ipv6, ' ', $addr_dst_ipv6, ' any -P ', "$out", ' ipsec ', $PROTO, "/transport/", $addr_src_ipv6, "-", $addr_dst_ipv6, '/require ' ,
					$PROTO_AUTH, "/transport/", $addr_src_ipv6, "-", $addr_dst_ipv6, '/require ;' ;
					if ($what eq 'full') {
					    print TMP "add ", $addr_dst_ipv6, ' ', $addr_src_ipv6, ' ', $PROTO, " 1000 -E ", $ALGO, ' ', $CLEF_CONF[$NUMCLEFCONF],
					    ";\n  add ", $addr_dst_ipv6, ' ', $addr_src_ipv6, ' ', $PROTO_AUTH, " 2000 -A ", $ALGO_AUTH, ' ', $CLEF_AUTH[$NUMCLEFAUTH], " ;\n spdadd ",
					    $addr_src_ipv6, ' ', $addr_dst_ipv6, ' any -P ', "$out", ' ipsec ', $PROTO, "/transport/", $addr_dst_ipv6, "-", $addr_src_ipv6, '/require ' ,
					    $PROTO_AUTH, "/transport/", $addr_dst_ipv6, "-", $addr_src_ipv6, '/require ;' ;
					}
				    } else { # ESP
					print TMP "add ", $addr_src_ipv6, ' ', $addr_dst_ipv6, ' ', $PROTO, " 1000 -E ", $ALGO, ' ', $CLEF_CONF[$NUMCLEFCONF],
					' -A ', $ALGO_AUTH, ' ', $CLEF_AUTH[$NUMCLEFAUTH], '; spdadd ', $addr_src_ipv6, ' ', $addr_dst_ipv6, ' any -P ', "$out", ' ipsec ',
					$PROTO, "/transport/", $addr_src_ipv6, "-", $addr_dst_ipv6, '/require ;' ;
					if ($what eq 'full') {
					    print TMP "add ", $addr_dst_ipv6, ' ', $addr_src_ipv6, ' ', $PROTO, " 1000 -E ", $ALGO, ' ', $CLEF_CONF[$NUMCLEFCONF],
					    ' -A ', $ALGO_AUTH, ' ', $CLEF_AUTH[$NUMCLEFAUTH], '; spdadd ', $addr_dst_ipv6, ' ', $addr_src_ipv6, ' any -P ', "$out", ' ipsec ',
					    $PROTO, "/transport/", $addr_dst_ipv6, "-", $addr_src_ipv6, '/require ;' ;
					}
				    }
#	    bb if (!v) { die "Erreur d'ecriture dans un fichier"} 
				    close TMP;
				    system ($SETKEY, '-f', '/tmp/tests.tmp') ;
				    
				    DOTEST ;
				    
				    reinit_tabs ;
				    $testnum++;
				    $NUMCLEFCONF++;
				}
				$NUMCLEFAUTH++;
			    }
			}
		    }
		}
	    }
	}
    }
}
close(CONTROLE);
