#!/usr/bin/perl -P
#tests IPsec/IPv6 en mode tunnel avec FreeBSD

use POSIX "sys_wait_h";
use Socket;

#Les emplacements des programmes et fichiers que l'on utilise. A changer si ncessaire
$SETKEY='/usr/sbin/setkey' ;            # setkey
$TTCP='/opt/ttcp6';                     # ttcp
$NETPERF='/opt/netperf/netperf';        # client netperf
$NETSERVER='/opt/netperf/netserver';    # serveur netperf
$TMPFILE='/tmp/tests.tmp';              # fichier temporaire pour passer les paramtres  setkey
$RESULTFILE='/tmp/tests_ipv6_results.txt'; #fichier o l on stocke les rsultats

$testnum = 0;

$typetest = 0;

# Fonction pour rinitialiser la SAD et la SPD
sub reinit_tabs {
    system $SETKEY , "-F";
    system $SETKEY , "-FP";
}

#affiche le mode d'emploi et quitte.
sub usage {
    die("Usage: \n \t tunnel.sh (-t|-r|-gw1|-gw2|-gw2r) addr_src_ipv6 addr_src_ipv4 hostname_src addr_gw1_ipv6 addr_gw1_ipv4 hostname_gw1 addr_gw2_ipv6 addr_gw2_ipv4 hostname_gw2 [addr_dst_ipv6 addr_dst_ipv4 hostname_dst]\n",
	"\t nb: you can ommit destination parameters if the gateway2 and the destination are identical\n",
	"\t nb: emitter must be launched last\n");
}


# Une petite macro pour ne pas recopier toujours la mme chose...
# !!! ATTENTION !!! On ne dtecte peut-tre pas toutes les erreurs! En cas d'erreur grave, il faut faire attention avec les rsultats, l'erreur peut s'tre produite 
# plus tt mais tre passe inaperue...
# Pour tre propre, il faudrait vrifier le numro du test
# (pour tre REELLEMENT propre, il ne faut pas faire de macro de 60 lignes ;-) !!!)
# notez en cas de debogage que l utilisation de cette macro pose des problmes de dcalage des numros de lignes
# il est alors conseill de la recopier partout o elle est ncessaire et d enlever le -P au dbut lors de l appel  Perl
# NE PAS METTRE DE COMMENTAIRES DANS LA MACRO
# notez galement que les commentaires commenant par un symbole du prprocesseur (si vous commentez un 'if' par exemple) sont  viter (rajouter qqch entre le '#' et le 'if')

#define DOTEST $recu = ' '; \
    if (($typetest != 3) && ($typetest != 4)) { \
    if ($typetest == 2) { \
	$nberr = 0; \
	while ($recu ne "OK\n") { \
	    recv(CONTROLE2, $recu, 3, 0); \
	}  \
	print "\nTest ttcp6\n"; \
	if ($tcp) { \
	    print "$TTCP -f m -t $addr_dst_ipv6 " ; \
	    while(system("$TTCP -b $send_socket_size -l $send_msg_size -f m -t $addr_dst_ipv6 >> $RESULTFILE ")) { \
		print "\n\n**** Une erreur s'est produite ****\n\n"; \
		if ($nberr++ >= 5) { \
		    die "\nErreur grave\n" \
		} \
	    } \
	    print "\nTest NetPerf \n"; \
	    system("$NETPERF -t TCPIPV6_STREAM -H $hostname_dst -- -S $recv_socket_size -s $send_socket_size -m $send_msg_size >> $RESULTFILE"); \
	    send(CONTROLE2, "OK\n", 0); \
	} else { \
	    while(system("$TTCP -b $send_socket_size -l $send_msg_size -u -f m -t $addr_dst_ipv6 >> $RESULTFILE")) { \
		print "\n\n**** Une erreur s'est produite ****\n\n"; \
		if ($nberr++ >= 5) { \
		    die "\nErreur grave\n" \
		    } \
		} \
	    print "\nTest NetPerf \n"; \
	    system("$NETPERF -t UDPIPV6_STREAM -H $hostname_dst -- -S $recv_socket_size -s $send_socket_size -m $send_msg_size >> $RESULTFILE"); \
	    send(CONTROLE2, "OK\n", 0); \
	} \
	} elsif (($typetest == 1) || ($typetest == 5)) { \
	    if ($tcp) { \
		print $TTCP, " -f m -r "; \
		if (($pid = fork)) { \
		    send(CONTROLE1, "OK\n", 0); \
		    waitpid($pid, 0); \
		} else { \
		    exec "$TTCP -b $recv_socket_size -l $send_msg_size -f m -r >> $RESULTFILE"; \
		} \
	    } else { \
		print $TTCP, " -u -f m -r "; \
		if (fork) { \
		    send(CONTROLE1, "OK\n", 0); \
		    waitpid($pid, 0); \
		} else { \
		    exec "$TTCP -b $recv_socket_size -l $send_msg_size -u -f m -r >> $RESULTFILE "; \
		} \
	    } \
	    while ($recu ne "OK\n") { \
		recv(CONTROLE1, $recu, 3, 0); \
	    } \
	} \
    } \
    if (($typetest == 3) || ($typetest == 4)) { \
	    while ($recu ne "OK\n") { \
	        recv(CONTROLE2, $recu, 3, 0); \
	    }  \
	    send(CONTROLE1, "OK\n", 0); \
        $recu = ' '; \
	while ($recu ne "OK\n") { \
	    recv(CONTROLE1, $recu, 3, 0); \
	} \
	send(CONTROLE2, "OK\n", 0); \
}                   

#Les clefs pour les tests. Il est possible de les changer mais il faut pour la plupart des algorithmes que la taille reste identique.

#Les clefs d'authentification  (AH comme ESP) pour les tests de, respectivement,
# 'hmac-md5', 'hmac-sha1', 'keyed-md5', 'keyed-sha1', 'hmac-sha2-256', 'hmac-sha2-384', 'hmac-sha2-512'
@CLEF_AUTH = ('"TESTtestTESTtest"', '"TESTtestTESTtestTEST"', '"TESTtestTESTtest"', '"TESTtestTESTtestTEST"',
	      '"TESTtestTESTtestTESTtestTESTtest"', '"TESTtestTESTtestTESTtestTESTtestTESTtestTESTtest"',
	      '"TESTtestTESTtestTESTtestTESTtestTESTtestTESTtestTESTtestTESTtest"');

# les clefs de chiffrement utilise par les tests correspondant respectivement 
# 'des-cbc', '3des-cbc', 'simple', 'simple', 'blowfish-cbc', 'blowfish-cbc', 'blowfish-cbc', 'cast128-cbc', 'des-deriv', 'rijndael-cbc', 'rijndael-cbc', 'rijndael-cbc'
# Les algorithmes prsents plusieurs fois sont test avec diffrentes tailles de clef.
# notez que rijndael-cbc n'est pas test car il semble ne pas fonctionner
@CLEF_CONF = ('"TESTtest"', '"TESTtestTESTtestTESTtest"', '""', '"TESTtestTESTtestTESTtestTESTtestTESTtestTESTtestTESTtestTESTtestTESTtest"',
	      '"TESTtestTESTtest"', '"TESTtestTESTtestTESTtestTESTtest"', '"TESTtestTESTtestTESTtestTESTtestTESTtestTESTtestTESTtest"',
	      '"TESTtestTESTtest"', '"TESTtest"', '"TESTtestTESTtest"', '"TESTtestTESTtestTESTtest"', '"TESTtestTESTtestTESTtestTESTtest"');

########

# On scanne les arguments
if (@ARGV != 13 && @ARGV != 10) {
    usage ;
}
if ($ARGV[0] eq "-r") {
    print "Mode recepteur\n";
    $typetest = 1;
    $out = 'in';
    $nout = 'out';
} elsif ($ARGV[0] eq "-t") {
    print "Mode emetteur\n"; 
    $typetest = 2;
    $out = 'out';
    $nout = 'in';
} elsif ($ARGV[0] eq "-gw1") {
    print "Mode passerelle mettrice\n";
    $typetest = 3;
    $out = 'out';
    $nout = 'in';
} elsif ($ARGV[0] eq "-gw2") {
    print "Mode passerelle rceptrice\n"; 
    $typetest = 4;
    $out = 'in';
    $nout = 'out';
} elsif ($ARGV[0] eq "-gw2r") {
    print "Mode passerelle rceptrice + rcepteur\n"; 
    $typetest = 5;
    $out = 'in';
    $nout = 'out';
} else {
    usage;
}

$addr_src_ipv6 = $ARGV[1];
$addr_src_ipv4 = $ARGV[2];
$hostname_src = $ARGV[3];
$addr_gw1_ipv6 = $ARGV[4];
$addr_gw1_ipv4 = $ARGV[5];
$hostname_gw1 = $ARGV[6];
$addr_gw2_ipv6 = $ARGV[7];
$addr_gw2_ipv4 = $ARGV[8];
$hostname_gw2 = $ARGV[9];
if (@ARGV == 13) {
    $addr_dst_ipv6 = $ARGV[10];
    $addr_dst_ipv4 = $ARGV[11];
    $hostname_dst = $ARGV[12];
} else {
    $addr_dst_ipv6 = $ARGV[7];
    $addr_dst_ipv4 = $ARGV[8];
    $hostname_dst = $ARGV[9];
}
############

#sockets de controle (pour la synchronisation)
# Les sockets de controle utilisent IPv4, IPv6 n'tant pas encore support par Perl en standard
if ($typetest != 2) {
    print "Etablissement de la socket de controle: en attente de connexion\n";
    socket(TEMP, AF_INET, SOCK_STREAM, 0) || die $! ;
    my $addr_local = sockaddr_in (12864, INADDR_ANY);
    bind (TEMP, $addr_local) || die $!;
    listen(TEMP, 1) ;
    accept(CONTROLE1, TEMP,) || die $!;
    close(TEMP);
}
if (($typetest != 1) && ($typetest != 5)) {
    print "Etablissement de la socket de controle: \n" ;
    socket(CONTROLE2, AF_INET, SOCK_STREAM, 0) || die $! ;
    my $addr_local = sockaddr_in (0, INADDR_ANY);
    if ($typetest == 2) {
	$addr_dist = sockaddr_in (12864, inet_aton($addr_gw1_ipv4));
    } elsif ($typetest == 3) {
	$addr_dist = sockaddr_in (12864, inet_aton($addr_gw2_ipv4));
    } elsif ($typetest == 4) {
	$addr_dist = sockaddr_in (12864, inet_aton($addr_dst_ipv4));
    }
    bind(CONTROLE2, $addr_local)|| die $!;
    connect (CONTROLE2, $addr_dist) || die $!;
}
print "Etablissement de la socket de controle: OK\n";
#############

#******** tests **********************


if (($typetest == 1) ||($typetest == 5))  {
# Lancement de netserver
    $pid=fork;
    if (!$pid) {
	exec "$NETSERVER -p 12865";
    }
}

# pour chaque type de test (authentification seule, chiffrement seul, chiffrement plus authentification (ESP seul ou ESP + AH))
# on positionne la SPD et la SAD avec setkey et on effectue le test (appel  la macro DOTEST) avant de remettre  0 IPsec et de
# passer au test suivant.
# ces types de tests sont rpts pour les diffrentes tailles de sockets, de messages, pour udp et tcp, ...

for ($tcp = 1; $tcp >= 0; $tcp--) {
    foreach $recv_socket_size ('65536', '32768', '8192', '4096') { ##taille du buffer de la socket  la rception
	foreach $send_socket_size ('65536', '32768', '8192', '4096') {##taille du buffer de la socket  l mission
	   foreach $send_msg_size ('4096', '8192', '32768') { ##taille des messages envoys (pour netperf) / du buffer de message (ttcp)
	       reinit_tabs;
	       print "\nTest N$testnum: tmoin\n";
	       $testnum++; 
	       DOTEST;

	       foreach $what ('half', 'full') { ## avec full, on utilise IPsec dans les deux sens. avec half, uniquement de l metteur vers le rcepteur

# IL semble que AH ne fonctionne pas en mode tunnel (pas de rponse du rcepteur)
# Dcommentez pour essayer.

#    print "\nTests d'authentification\n";
#    foreach $PROTOTUN ('ah') { # ah. mais des pbs -> dsactiv pour le moment
#	$NUMCLEFAUTHTUN = 3;
#	foreach $ALGOTUN ( 'hmac-md5', 'hmac-sha1', 'keyed-md5', 'keyed-sha1', 'hmac-sha2-256', 'hmac-sha2-384', 'hmac-sha2-512') {
#           open(RESULTS, ">>/tmp/tests_ipv6_results.txt") or die "Could not open /tmp/tests_ipv6_results.txt\n";
#	    print RESULTS "\n\nTest N", $testnum, ' Protocole d\'authentification tunnel: ', $PROTOTUN, '; Algorithme: ', $ALGOTUN, "\n";
#	    print "\n\nTest N", $testnum, ' Protocole d\'authentification tunnel: ', $PROTOTUN, '; Algorithme: ', $ALGOTUN, "\n";
#j	    if ($typetest >= 3) {
#		open ( TMP, ">$TMPFILE") or die "Could not open $TMPFILE\n";
#		print TMP "add $addr_gw1_ipv6 $addr_gw2_ipv6 $PROTOTUN 1000 -m tunnel -A $ALGOTUN $CLEF_AUTH[$NUMCLEFAUTHTUN] ;",
#		" spdadd $addr_src_ipv6/128 $addr_dst_ipv6/128 any -P $out ipsec $PROTOTUN/tunnel/$addr_gw1_ipv6-$addr_gw2_ipv6/require ;" ;
#j              if ($what eq 'full') {
#                   print TMP "add $addr_gw2_ipv6 $addr_gw1_ipv6 $PROTOTUN 2000 -m tunnel -A $ALGOTUN $CLEF_AUTH[$NUMCLEFAUTHTUN] ;",
#		    " spdadd $addr_dst_ipv6/128 $addr_src_ipv6/128 any -P $nout ipsec $PROTOTUN/tunnel/$addr_gw2_ipv6-$addr_gw1_ipv6/require ;" ;
#	        }
#		close TMP ;
#		system ($SETKEY, '-f', $TMPFILE) ;
#           }
#	    print "recv_socket_size: $recv_socket_size ; send_socket_size: $send_socket_size ; send_msg_size: $send_msg_size ; tcp: $tcp; sens: $what\n";
#	    print RESULTS "recv_socket_size: $recv_socket_size ; send_socket_size: $send_socket_size ; send_msg_size: $send_msg_size ; tcp: $tcp; sens: $what\n";
#           close RESULTS;
#	    DOTEST ;
#	    reinit_tabs ;
#	    $testnum++;
#	    $NUMCLEFAUTHTUN++;
#	}
#   }
#    print "\nTests d'authentification termins\n";
 
		   print "\n tests de confidentialit";
		   foreach $PROTOCONFTUN ('esp') {
		       $NUMCLEFCONFTUN = 0;
		       foreach $ALGOCONFTUN ('des-cbc', '3des-cbc', 'simple', 'simple', 'blowfish-cbc', 'blowfish-cbc', 'blowfish-cbc', 'cast128-cbc', 'des-deriv') { # ne marche pas avec l''AES: POURQUOI???? , 'rijndael-cbc', 'rijndael-cbc', 'rijndael-cbc'
			   open(RESULTS, ">>/tmp/tests_ipv6_results.txt") or die "Could not open /tmp/tests_ipv6_results.txt\n";
			   print RESULTS "\n\nTest N $testnum Protocole de confidentialit tunnel: $PROTOCONFTUN; Algorithme: $ALGOCONFTUN Clef utilise: $CLEF_CONF[$NUMCLEFCONFTUN]\n";
			   print "\n\nTest N $testnum Protocole de confidentialit tunnel: $PROTOCONFTUN; Algorithme: $ALGOCONFTUN Clef utilise: $CLEF_CONF[$NUMCLEFCONFTUN]\n";
			   if ($typetest >= 3) {
			       open ( TMP, ">$TMPFILE") or die "Could not open $TMPFILE\n";
			       print TMP "add $addr_gw1_ipv6 $addr_gw2_ipv6 $PROTOCONFTUN 1000 -m tunnel -E $ALGOCONFTUN $CLEF_CONF[$NUMCLEFCONFTUN] ; ",
			       " spdadd $addr_src_ipv6/128 $addr_dst_ipv6/128 any -P $out ipsec $PROTOCONFTUN/tunnel/$addr_gw1_ipv6-$addr_gw2_ipv6/require ; " ;
			       if ($what eq 'full') {
				   print TMP "add $addr_gw2_ipv6 $addr_gw1_ipv6 $PROTOCONFTUN 2000 -m tunnel -E $ALGOCONFTUN $CLEF_CONF[$NUMCLEFCONFTUN] ; ", 
				   " spdadd $addr_dst_ipv6/128 $addr_src_ipv6/128 any -P $nout ipsec $PROTOCONFTUN/tunnel/$addr_gw2_ipv6-$addr_gw1_ipv6/require ; " ;
			       }

			       close TMP ;
			       system ($SETKEY, '-f', $TMPFILE) ;
			   }
			   print "recv_socket_size: $recv_socket_size ; send_socket_size: $send_socket_size ; send_msg_size: $send_msg_size ; tcp: $tcp; sens: $what\n";
			   print RESULTS "recv_socket_size: $recv_socket_size ; send_socket_size: $send_socket_size ; send_msg_size: $send_msg_size ; tcp: $tcp; sens: $what\n";
			   close RESULTS ;
			   DOTEST ;
			   reinit_tabs ;
			   $testnum++;
			   $NUMCLEFCONFTUN++;
		       }
		   }
		   print "\n tests de confidentialit termins \n";
		   
		   print "\n tests de confidentialit avec authentification simultane\n";
		   foreach $PROTOAUTHTUN ('esp') {  # Problme avec AH. Il est nanmoins possible de l ajouter  la liste pour le tester.
		       $NUMCLEFAUTHTUN = 0;
		       foreach $ALGOAUTHTUN ('hmac-md5', 'hmac-sha1', 'keyed-md5', 'keyed-sha1', 'hmac-sha2-256', 'hmac-sha2-384', 'hmac-sha2-512') {
			   foreach $PROTOCONFTUN ('esp') {
			       $NUMCLEFCONFTUN = 0;
			       foreach $ALGOCONFTUN ('des-cbc', '3des-cbc', 'simple', 'simple', 'blowfish-cbc', 'blowfish-cbc', 'blowfish-cbc', 'cast128-cbc', 'des-deriv') { # ne marche pas avec l''AES: POURQUOI???? , 'rijndael-cbc', 'rijndael-cbc', 'rijndael-cbc'
				   open(RESULTS, ">>/tmp/tests_ipv6_results.txt") or die "Could not open /tmp/tests_ipv6_results.txt\n";
				   print "\n\nTest N $testnum Protocole d'authentification tunnel: $PROTOAUTHTUN; Algorithme: $ALGOAUTHTUN\n";
				   print "Test N $testnum Protocole de confidentialit tunnel: $PROTOCONFTUN; Algorithme: $ALGOCONFTUN; Clef utilise: $CLEF_CONF[$NUMCLEFCONFTUN]\n";
				   print RESULTS "\n\nTest N $testnum Protocole d'authentification tunnel: $PROTOAUTHTUN; Algorithme: $ALGOAUTHTUN\n";
				   print RESULTS "Test N $testnum Protocole de confidentialit tunnel: $PROTOCONFTUN; Algorithme: $ALGOCONFTUN; Clef utilise: $CLEF_CONF[$NUMCLEFCONFTUN]\n";
				   if ($typetest >= 3) {
				       open ( TMP, ">$TMPFILE") or die "Could not open $TMPFILE\n";
				       if ($PROTOAUTHTUN eq 'esp') {
					   print TMP "add $addr_gw1_ipv6 $addr_gw2_ipv6 $PROTOCONFTUN 1000 -m tunnel -E $ALGOCONFTUN $CLEF_CONF[$NUMCLEFCONFTUN] -A $ALGOAUTHTUN $CLEF_AUTH[$NUMCLEFAUTHTUN];",
					   " spdadd $addr_src_ipv6/128 $addr_dst_ipv6/128 any -P $out ipsec $PROTOCONFTUN/tunnel/$addr_gw1_ipv6-$addr_gw2_ipv6/require ; " ;
					   if ($what eq 'full') {
					       print TMP "add $addr_gw2_ipv6 $addr_gw1_ipv6 $PROTOCONFTUN 2000 -m tunnel -E $ALGOCONFTUN $CLEF_CONF[$NUMCLEFCONFTUN] -A $ALGOAUTHTUN $CLEF_AUTH[$NUMCLEFAUTHTUN];",
					       " spdadd $addr_dst_ipv6/128 $addr_src_ipv6/128 any -P $nout ipsec $PROTOCONFTUN/tunnel/$addr_gw2_ipv6-$addr_gw1_ipv6/require ; " ;
					   }
				       } else {
					   print TMP "add $addr_gw1_ipv6 $addr_gw2_ipv6 $PROTOCONFTUN 1000 -m tunnel -E $ALGOCONFTUN $CLEF_CONF[$NUMCLEFCONFTUN] -A $ALGOAUTHTUN $CLEF_AUTH[$NUMCLEFAUTHTUN];",
					   "add $addr_gw1_ipv6 $addr_gw2_ipv6 $PROTOAUTHTUN 2000 -m tunnel -A $ALGOAUTHTUN $CLEF_AUTH[$NUMCLEFAUTHTUN];",
					   " spdadd $addr_src_ipv6/128 $addr_dst_ipv6/128 any -P $out ipsec $PROTOCONFTUN/tunnel/$addr_gw1_ipv6-$addr_gw2_ipv6/require $PROTOAUTHTUN/tunnel/$addr_gw1_ipv6-$addr_gw2_ipv6/require ; " ;
					   if ($what eq 'full') {
					       print TMP "add $addr_gw2_ipv6 $addr_gw1_ipv6 $PROTOCONFTUN 3000 -m tunnel -E $ALGOCONFTUN $CLEF_CONF[$NUMCLEFCONFTUN] -A $ALGOAUTHTUN $CLEF_AUTH[$NUMCLEFAUTHTUN];",
					       "add $addr_gw2_ipv6 $addr_gw1_ipv6 $PROTOAUTHTUN 4000 -m tunnel -A $ALGOAUTHTUN $CLEF_AUTH[$NUMCLEFAUTHTUN];",
					       " spdadd $addr_dst_ipv6/128 $addr_src_ipv6/128 any -P $nout ipsec $PROTOCONFTUN/tunnel/$addr_gw1_ipv6-$addr_gw2_ipv6/require $PROTOAUTHTUN/tunnel/$addr_gw2_ipv6-$addr_gw1_ipv6/require ;" ;
					   }
				       }
				       close TMP ;
				       system ($SETKEY, '-f', $TMPFILE) ;
				   }
				   print "recv_socket_size: $recv_socket_size ; send_socket_size: $send_socket_size ; send_msg_size: $send_msg_size ; tcp: $tcp; sens: $what\n";
				   print RESULTS "recv_socket_size: $recv_socket_size ; send_socket_size: $send_socket_size ; send_msg_size: $send_msg_size ; tcp: $tcp; sens: $what\n";
				   close RESULTS ;
				   DOTEST ;
				   reinit_tabs ;
				   $testnum++;
				   $NUMCLEFCONFTUN++;
			       }
			   }
			   $NUMCLEFAUTHTUN++;
		       }
		   }
	       }
	   }
       }
    }
}

kill 'TERM', $pid; # on tue netserver
close CONTROLE1;
close CONTROLE2;
